%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Name:		nufw
Version:	2.2.20
Release:	1%{dist}
Summary:	Authentication Firewall Suite for Linux
License:	GPLv2
Group:		System Environment/Daemons
Source:		http://www.nufw.org/download/nufw/%{name}-%{version}.tar.bz2
Source1: nufw.init
Source2: nuauth.init
Source3: nuauth.pam
Source4: setup-python_nufw.py
Source5: version-python_nufw.py
Source6: README.python_nufw
Patch0: %{name}-avoid-version.patch
URL:		http://www.nufw.org/

Requires: iptables python-IPy
Requires(pre): shadow-utils
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
BuildRequires: postgresql-devel mysql-devel
BuildRequires: libtasn1-devel gnutls-devel glib2-devel pam-devel cyrus-sasl-devel chrpath
BuildRequires: openldap-devel iptables-devel
BuildRequires: libprelude-devel libnetfilter_queue-devel libnetfilter_conntrack-devel libnfnetlink-devel
BuildRequires: python-IPy python-setuptools python-devel
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
NuFW is a firewall able to filter connection according to user uid or user
software, meaning you can allows port 80 for only one user, whatever ip he
uses, or only for konqueror.

NuFW performs an authentication of every single connection passing through the
IP filter, by transparently requesting user's credentials before any filtering
decision is taken. Practically, this means security policies can integrate with
the users directory, and bring the notion of user ID down to the IP layers.

%package utils
Summary: Various utilities for Nufw administrators
Group: Applications/Internet
%description utils
This package contains various utilities :

  * nutop : a top-like utility to watch connection

  * nuaclgen : a perl script to add users to ldap

%package -n libnuclient
Summary: Nuclient library
Group: System Environment/Libraries
Provides: libnuclient = %{version}-%{release}
%description -n libnuclient
Library needed by nufw for nuclient.

%package -n libnuclient-devel
Summary: Nuclient development library
Group: Development/Libraries
Provides: libnuclient-devel = %{version}-%{release}
Requires: libnuclient = %{version}-%{release}
%description -n libnuclient-devel
Development file of the nuclient library, used to compile
client accessing to nufw.

%package -n pam_nufw
Summary: Nufw client using pam credentials
Group: System Environment/Libraries
BuildRequires: chrpath

%description -n pam_nufw
pam_nufw is a PAM module able to integrate with the PAM stack.
It reuse pam credentials to connect to nufw daemon, instead of requiring to
start nutcpc by hand.

%package nutcpc
Summary: Nufw client
Group: Networking/Other
%description nutcpc
Nutcpc is the command line client used to authenticate on a firewall using
nufw.

%package  nuauth
Summary: Nufw user database daemon
Group: System Environment/Daemons
Requires: cyrus-sasl-login cyrus-sasl-plain python-IPy perl-ldap
Provides: nufw-nuauth-auth-plaintext = %{version}-%{release}
Provides: nufw-nuauth-log-syslog = %{version}-%{release}
Provides: nufw-nuauth-auth-system = %{version}-%{release}

%description   nuauth
NuFW is an authenticating gateway, which means that connections are
authenticated before being forwarded through the gateway. Classical packet
filtering systems disregard the identity of the user who may be attempting
to access the network, instead caring only about the originating IP addresses.

Nuauth lays on a user database, and an ACL system (which can reside in an LDAP
directory, etc. Nuauth receives requests from nufw, and auth packets from
users' clients, and sends decision to the nufw daemon.

This package contains the main daemon.

%package nuauth-auth-ldap
Summary: Module for nuauth providing ldap user database
Group: System Environment/Libraries
%description nuauth-auth-ldap
This package provides a module to use ldap as user database for nuauth.

%package nuauth-log-mysql
Summary: Module for nuauth to log in Mysql database
Group: System Environment/Libraries
%description nuauth-log-mysql
This module allows you to log user activity in a mysql database.

%package nuauth-log-pgsql
Summary: Module for nuauth to log in Postgresql database
Group: System Environment/Libraries
%description nuauth-log-pgsql
This module allows you to log user activity in a postgresql database.

%package nuauth-log-prelude
Summary: Module for nuauth to log to Prelude IDS
Group: System Environment/Libraries
%description nuauth-log-prelude
This module allows you to log user activity to the Prelude IDS.

%package -n python-nufw
Summary: Python bindings for NuFW client (nutcpc)
Group: Development/Languages
BuildRequires: python
BuildRequires: python-devel
BuildRequires: python-setuptools-devel
%description -n python-nufw
Bindings Python and nutcpc client for NuFW.

%prep
%setup -q
%patch0 -p1 -b .avoid-version

# fix postgresql name
perl -pi -e "s|postgresql|pgsql|" ./src/nuauth/modules/log_pgsql/Makefile*

perl -pi -e 's|^(modulesdir\s*=\s*/)lib|$1%_lib|' ./src/clients/pam_nufw/Makefile*
perl -pi -e 's|(\@modulesdir\s*=\s*/)lib|$1%_lib|' ./src/clients/pam_nufw/Makefile*

# fix nuauth-utils build
perl -pi -e 's|\$\(prefix\)|\%\{buildroot\}|' ./scripts/nuauth_command/Makefile*

%build
%configure \
 --sysconfdir=%{_sysconfdir}/nufw/ \
 --with-mysql-log --with-pgsql-log --with-system-auth --with-ldap \
 --with-nfqueue --with-nfconntrack --with-fixedtimeout --with-utf8 \
 --enable-pam-nufw --with-prelude-log

perl -pi -e 's|(install -d \$\(localstatedir\)/run/nuauth/)|#$1|'  ./src/nuauth/Makefile
make

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install

#install python bindings
cp %{SOURCE4} python/setup.py
cp %{SOURCE5} python/nuclient/version.py
cp %{SOURCE5} python/README
cd python; %{__python} setup.py install --no-compil --root=%{buildroot}; cd ..

cp -p scripts/nuaclgen %{buildroot}/%{_bindir}
cp -p scripts/nutop %{buildroot}/%{_bindir}

mkdir -p %{buildroot}/%{_sysconfdir}/nufw
cp -p conf/{nutop,nuauth,nuaclgen}.conf  %{buildroot}/%{_sysconfdir}/nufw
cp -p conf/{acls.nufw,periods.xml} %{buildroot}/%{_sysconfdir}/nufw
cp -p -R conf/certs/* %{buildroot}/%{_sysconfdir}/nufw
cp -p conf/users-plaintext.nufw %{buildroot}/%{_sysconfdir}/nufw/users.nufw

mkdir -p %{buildroot}/%{_localstatedir}/lib/nuauth
mkdir -p %{buildroot}/%{_localstatedir}/run/nuauth
# clean useless files
rm -f %{buildroot}/%{_libdir}/nuauth/modules/*.{a,la}
rm -f %{buildroot}/%{_lib}/security/*{a,la}
rm -f %{buildroot}/%{_libdir}/libnobuffer*

mkdir -p %{buildroot}/%_initrddir/
install -m755 %SOURCE1 %{buildroot}/%_initrddir/nufw
install -m755 %SOURCE2  %{buildroot}/%_initrddir/nuauth
mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig/
cat > %{buildroot}/%{_sysconfdir}/sysconfig/nufw << EOF
# daemon verbosity
#VERBOSITY="vv"

# address where nufw listen ( -L )
#LISTEN_ADDRESS="127.0.0.1"

# default port -l
#LISTEN_UDP_PORT="4129"

# nuauth address ( -d )
#NUAUTH_ADDRESS="127.0.0.1"

# nuauth port ( -p )
#NUAUTH_UDP_PORT=4128

# Firewall timeout ( -t )
#FW_TIMEOUT=15

# Track size ( -T )
#TRACK_SIZE=1000


EOF

mkdir %{buildroot}/%{_sysconfdir}/pam.d/
cp -p %SOURCE3 %{buildroot}/%{_sysconfdir}/pam.d/nuauth

%clean
rm -rf %{buildroot}

%post
/sbin/ldconfig
/sbin/chkconfig --add nufw

%postun -p /sbin/ldconfig

%preun
if [ $1 = 0 ] ; then
 /sbin/service nufw stop >/dev/null 2>&1
 /sbin/chkconfig --del nufw
fi

%pre nuauth
getent group nuauth >/dev/null || groupadd -r nuauth
getent passwd nuauth >/dev/null || \
useradd -r -g nuauth -d %{_localstatedir}/lib/nuauth -s /sbin/nologin \
-c "Privilege-separated Nuauth" nuauth
exit 0

%post nuauth
/sbin/chkconfig --add nuauth

%postun nuauth
/usr/sbin/userdel nuauth

%preun nuauth
if [ $1 = 0 ] ; then
 /sbin/service nuauth stop >/dev/null 2>&1
 /sbin/chkconfig --del nuauth
fi

%files
%defattr(-, root, root, -)
%doc AUTHORS ChangeLog NEWS README TODO COPYING
%doc doc/acls doc/cache_system doc/debug
%{_sbindir}/nufw
%{_mandir}/man8/nufw.8*
%config(noreplace) %{_initrddir}/nufw
%config(noreplace) %{_sysconfdir}/sysconfig/nufw
%dir %{_sysconfdir}/nufw/

%files utils
%defattr(-, root, root, -)
%{_bindir}/nuaclgen
%{_bindir}/nutop
%{_mandir}/man8/nuaclgen.8*
%{_mandir}/man8/nutop.8*
%config(noreplace) %{_sysconfdir}/nufw/nutop.conf
%config(noreplace) %{_sysconfdir}/nufw/nuaclgen.conf
%dir %{_sysconfdir}/nufw/

%files -n libnuclient
%defattr(-, root, root, -)
%{_libdir}/libnuclient.so.*

%files -n libnuclient-devel
%defattr(-, root, root, -)
%exclude %{_libdir}/libnuclient.a
%exclude %{_libdir}/libnuclient.la
%{_libdir}/libnuclient.so
%{_includedir}/*
%{_mandir}/man3/libnuclient.3*

%files -n pam_nufw
%defattr(-, root, root, -)
%doc doc/README.pam_nufw
/%{_lib}/security/pam_nufw.so

%files nuauth-auth-ldap
%defattr(-, root, root, -)
%doc conf/acls.schema
%{_libdir}/nuauth/modules/libldap.so*

%files nuauth-log-mysql
%defattr(-, root, root, -)
%doc conf/nulog*mysql.dump
%{_libdir}/nuauth/modules/libmysql.so*

%files nuauth-log-pgsql
%defattr(-, root, root, -)
%doc conf/nulog*pgsql.dump
%{_libdir}/nuauth/modules/libpgsql.so*

%files nuauth-log-prelude
%defattr(-, root, root, -)
%{_libdir}/nuauth/modules/libnuprelude.so*

%files nuauth
%defattr(-, root, root, -)
%{_sbindir}/nuauth
%{_mandir}/man8/nuauth.8*
%{_mandir}/man5/nuclient.conf.5*
%{_localstatedir}/lib/nuauth
%dir %{_localstatedir}/run/nuauth/
%config(noreplace) %{_initrddir}/nuauth
%config(noreplace) %{_sysconfdir}/%{name}/nuauth.conf
%config(noreplace) %{_sysconfdir}/%{name}/periods.xml
%config(noreplace) %{_sysconfdir}/%{name}/users.nufw
%config(noreplace) %{_sysconfdir}/%{name}/acls.nufw
%config(noreplace) %{_sysconfdir}/%{name}/*pem
%config(noreplace) %{_sysconfdir}/pam.d/nuauth
%dir %{_sysconfdir}/%{name}/
%{_libdir}/nuauth/modules/libsyslog.so*
%{_libdir}/nuauth/modules/libplaintext.so*
%{_libdir}/nuauth/modules/libsystem.so*
%{_libdir}/nuauth/modules/libscript.so*
%{_libdir}/nuauth/modules/libx509_std.so*
%{_libdir}/nuauth/modules/libxml_defs.so*
%{_libdir}/nuauth/modules/libipauth_guest.so*
%{_libdir}/nuauth/modules/libmark_field.so*
%{_libdir}/nuauth/modules/libmark_flag.so*
%{_libdir}/nuauth/modules/libmark_group.so*
%{_libdir}/nuauth/modules/libmark_uid.so*
%{_libdir}/nuauth/modules/libsession_expire.so*
%{_libdir}/nuauth/modules/libsession_authtype.so*

%files nutcpc
%defattr(-, root, root, -)
%{_bindir}/nutcpc
%{_mandir}/man1/nutcpc.1*

%files -n python-nufw
%defattr(-, root, root)
%{python_sitelib}/*egg-info
%{python_sitelib}/nuclient/*

%changelog
* Mon Dec 10 2008 Jerome Soyer <saispo@gmail.com> 2.2.20-1
- Initial Fedora Package
